/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mappings are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2004 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */

package jorm;

import org.objectweb.jorm.naming.api.PBinder;
import org.objectweb.jorm.naming.api.PExceptionNaming;
import org.objectweb.jorm.api.PExceptionProtocol;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.naming.api.PName;
import org.objectweb.jorm.naming.api.PNameCoder;
import org.objectweb.jorm.api.PSerializable;
import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PAccessorGen;
import org.objectweb.jorm.api.PClassMapping;

public class JE2_CustomerSerializable implements PSerializable, JE2_CustomerAccessor {

	//the pname of the object
	protected String pName;
	
		protected  String creditCard;
			protected java.lang.String firstName;
			protected boolean hasGoodCredit;
			protected  String homeAddress;
			protected java.lang.Integer id;
			protected java.lang.String lastName;
			protected  String phoneNumbers;
			protected  String reservations;
	
	public String setPName(PName pName){
		if(pName.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				this.pName  = pName.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			this.pName = "null";
		}
		return this.pName;
	}
	
	public PName getPName(PBinder pnc) throws PExceptionNaming{
		try{
			return pnc.decodeString(pName);
		}catch (Exception e) {
              throw new PExceptionNaming("Cannot decode to a PName: " + e.getMessage());
        }
	}
	
	public String getClassName(){
		return "jorm.JE2_Customer";
	}
	

	public void paSetCreditCard(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				creditCard = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			creditCard = "null";
		}
	}
	
	public PName paGetCreditCard(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("creditCard");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(creditCard);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetFirstName(java.lang.String val){
		firstName = val;
	}
	public java.lang.String paGetFirstName() {
		return firstName;
	}

	public void paSetHasGoodCredit(boolean val){
		hasGoodCredit = val;
	}
	public boolean paGetHasGoodCredit() {
		return hasGoodCredit;
	}

	public void paSetHomeAddress(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				homeAddress = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			homeAddress = "null";
		}
	}
	
	public PName paGetHomeAddress(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("homeAddress");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(homeAddress);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetId(java.lang.Integer val){
		id = val;
	}
	public java.lang.Integer paGetId() {
		return id;
	}

	public void paSetLastName(java.lang.String val){
		lastName = val;
	}
	public java.lang.String paGetLastName() {
		return lastName;
	}

	public void paSetPhoneNumbers(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				phoneNumbers = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			phoneNumbers = "null";
		}
	}
	
	public PName paGetPhoneNumbers(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("phoneNumbers");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(phoneNumbers);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetReservations(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				reservations = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			reservations = "null";
		}
	}
	
	public PName paGetReservations(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("reservations");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(reservations);
		}
		catch(PException e){
			return null;
		}
	}

	public Object getMemoryInstance(){
		return this;
	}
	
	
	public String toString(){
		StringBuffer s = new StringBuffer();
		s.append("data(");
					s.append(creditCard + ",  ");
					s.append(firstName + ",  ");
					s.append(hasGoodCredit + ",  ");
					s.append(homeAddress + ",  ");
					s.append(id + ",  ");
					s.append(lastName + ",  ");
					s.append(phoneNumbers + ",  ");
					s.append(reservations + ",  ");
				s.append(pName + ")");
		return s.toString();
	}
	
	
	public void read(PClassMapping pcm, PAccessor pa) throws PException{
		JE2_CustomerAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PException("Accessor must not be null");
		else if (pa instanceof JE2_CustomerAccessor)
			paccessor = (JE2_CustomerAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PException("Wrong type of accessor: " + pa);
	 	try {	
			if(paccessor != null){
											paccessor.paSetCreditCard(paGetCreditCard(pcm), null);
															paccessor.paSetFirstName(paGetFirstName());
															paccessor.paSetHasGoodCredit(paGetHasGoodCredit());
															paccessor.paSetHomeAddress(paGetHomeAddress(pcm), null);
															paccessor.paSetId(paGetId());
															paccessor.paSetLastName(paGetLastName());
															paccessor.paSetPhoneNumbers(paGetPhoneNumbers(pcm), null);
															paccessor.paSetReservations(paGetReservations(pcm), null);
							 			}
 			else{
	  		 						 			        		//paccessorGen.paSetStringField("firstName", paGetFirstName(pcm), null);
	        			 			        		//paccessorGen.paSetBooleanField("hasGoodCredit", paGetHasGoodCredit(pcm), null);
	        			 						 			        		//paccessorGen.paSetOintField("id", paGetId(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("lastName", paGetLastName(pcm), null);
	        			 						 						        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
	
	public void write(PClassMapping pcm, PAccessor pa) throws PException{
		JE2_CustomerAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PExceptionProtocol("Accessor must not be null");
		else if (pa instanceof JE2_CustomerAccessor)
			paccessor = (JE2_CustomerAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PExceptionProtocol("Wrong type of accessor: " + pa);
		try {	
			if(paccessor != null){
											paSetCreditCard(paccessor.paGetCreditCard(pcm), null);
															paSetFirstName(paccessor.paGetFirstName());
															paSetHasGoodCredit(paccessor.paGetHasGoodCredit());
															paSetHomeAddress(paccessor.paGetHomeAddress(pcm), null);
															paSetId(paccessor.paGetId());
															paSetLastName(paccessor.paGetLastName());
															paSetPhoneNumbers(paccessor.paGetPhoneNumbers(pcm), null);
															paSetReservations(paccessor.paGetReservations(pcm), null);
							 			}
 			else{
	  		 						 				        	//	paSetStringField(firstName, paccessorGen.paGetFirstName());
        		//paSetStringField("firstName", paccessorGen.paGetStringField("firstName"));
        		//paSetFirstName(paccessorGen.paGetStringField("firstName"), null);
	        			 				        	//	paSetBooleanField(hasGoodCredit, paccessorGen.paGetHasGoodCredit());
        		//paSetBooleanField("hasGoodCredit", paccessorGen.paGetBooleanField("hasGoodCredit"));
        		//paSetHasGoodCredit(paccessorGen.paGetBooleanField("hasGoodCredit"), null);
	        			 						 				        	//	paSetOintField(id, paccessorGen.paGetId());
        		//paSetOintField("id", paccessorGen.paGetOintField("id"));
        		//paSetId(paccessorGen.paGetOintField("id"), null);
	        			 				        	//	paSetStringField(lastName, paccessorGen.paGetLastName());
        		//paSetStringField("lastName", paccessorGen.paGetStringField("lastName"));
        		//paSetLastName(paccessorGen.paGetStringField("lastName"), null);
	        			 						 						        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
}